org.springframework.batch.item.support

## Class IteratorItemReader<T>

- java.lang.Object
- - org.springframework.batch.item.support.IteratorItemReader<T>

- All Implemented Interfaces:
    ItemReader<T>

      public class IteratorItemReader<T>
      extends java.lang.Object
      implements ItemReader<T>

  An `ItemReader` that pulls data from a `Iterator` or `Iterable` using the constructors.
  Author:
    Juliusz Brzostek, Dave Syer

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `IteratorItemReader(java.lang.Iterable<T> iterable)` Construct a new reader from this iterable (could be a collection), by extracting an instance of `Iterator` from it.
    `IteratorItemReader(java.util.Iterator<T> iterator)` Construct a new reader from this iterator directly.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `T` | `read()` Implementation of `ItemReader.read()` that just iterates over the iterator provided.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### IteratorItemReader

          public IteratorItemReader(java.lang.Iterable<T> iterable)

      Construct a new reader from this iterable (could be a collection), by extracting an instance of `Iterator` from it.
      Parameters:
        `iterable` - in instance of `Iterable`
      See Also:
        `Iterable.iterator()`

    - #### IteratorItemReader

          public IteratorItemReader(java.util.Iterator<T> iterator)

      Construct a new reader from this iterator directly.
      Parameters:
        `iterator` - an instance of `Iterator`

  - ### Method Detail

    - #### read

          public T read()
                 throws java.lang.Exception,
                        UnexpectedInputException,
                        ParseException

      Implementation of `ItemReader.read()` that just iterates over the iterator provided.
      Specified by:
        `read` in interface `ItemReader<T>`
      Returns:
        T the item to be processed
      Throws:
        `ParseException` - if there is a problem parsing the current record (but the next one may still be valid)
        `NonTransientResourceException` - if there is a fatal exception in the underlying resource. After throwing this exception implementations should endeavour to return null from subsequent calls to read.
        `UnexpectedInputException` - if there is an uncategorised problem with the input data. Assume potentially transient, so subsequent calls to read might succeed.
        `java.lang.Exception` - if an there is a non-specific error.